﻿using CefSharp;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Utils;

namespace CefSharpDemo
{
    /// <summary>
    /// CefSharp Demo 窗体
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            tabControl.AddTabItemEvent += tabControl_AddTabItemEvent;
            Application.Current.MainWindow = this;
        }

        private void tabControl_AddTabItemEvent(object sender, EventArgs e)
        {
            //CreateTabItem("https://www.cnblogs.com/");
            CreateTabItem("file:///D:/_程序/CefSharpDemo/post.html");
        }

        /// <summary>
        /// 新增Tab页
        /// </summary>
        private void CreateTabItem(string url = null, IRequest request = null)
        {
            TabItem tabItem = new TabItem();
            tabItem.Header = "新标签页";
            BrowserDemoCtrl ctrl = new BrowserDemoCtrl();
            ctrl.browserCtrl.Browser.StartNewWindow += (s, e) =>
            {
                CreateTabItem(e.TargetUrl, e.Request);
            };
            ctrl.browserCtrl.SetUrlEvent += (s, e) =>
            {
                ctrl.browserCtrl.Url = url;
                ctrl.browserCtrl.Request = request;
            };
            tabItem.Content = ctrl;
            tabControl.Items.Add(tabItem);
            tabControl.SelectedItem = tabItem;
            ScrollViewer scrollViewer = tabControl.Template.FindName("scrollViewer", tabControl) as ScrollViewer;
            scrollViewer.ScrollToRightEnd();
        }

        private void Window_Closed(object sender, EventArgs e)
        {
            tabControl.CloseAllTabItem(); //关闭窗体清理资源

            //程序退出时删除cache
            CefSharp.Cef.Shutdown();
            string cachePath = AppDomain.CurrentDomain.BaseDirectory + "CefSharp\\cache";
            if (Directory.Exists(cachePath))
            {
                foreach (string path in Directory.GetDirectories(cachePath))
                {
                    Directory.Delete(path, true);
                }
                foreach (string file in Directory.GetFiles(cachePath))
                {
                    if (!file.ToLower().Contains("cookies"))
                    {
                        File.Delete(file);
                    }
                }
            }
        }
    }
}
